/*
 * Client.java
 *
 * Created on 6. februar 2001, 00:08
 */

package com.bekk.dbcdemo;

/**
 * This client does not verify preconditions before calling the supplier. That's a BUG
 *
 * @author  <a href="mailto:aslak.hellesoy@bekk.no">Aslak Hellesy</a>
 */
public class Client{

	private static Flight flight = new FlightImpl( "Spantax 666" );

	/**
	 * Creates a passenger and tries to send it to New York
	 *
	 * @param kilos weight of the passenger's luggage
	 */
	private static void checkin( Passenger passenger ) {

		String destination = flight.accept( passenger );
		System.out.println( "flight " + flight.getName() + " took the passenger to " + destination );

		// TO FIX THE BUG, COMMENT OUT THE TWO LINES ABOVE AND UNCOMMENT THE ONES BELOW

		// We're verifying that the contract is fulfilled.
		/*
		if( passenger.getHandLuggageWeight() <= Flight.MAX_HAND_LUGGAGE_WEIGHT &&
		    flight.getPassengers() < Flight.MAX_PASSENGERS ) {
			String destination = flight.accept( passenger );
			System.out.println( "flight " + flight.getName() + " took the passenger to " + destination );
		} else {
			System.out.println( "flight " + flight.getName() + " will not take the passenger." );
		}
		*/
	}

	/**
	 * Runs the Client
	 */
	public static void main( String[] args ) {
		int kilos = Integer.parseInt( args[ 0 ] );

		Passenger passenger = new PassengerImpl( "New York", kilos, true );
		checkin( passenger );
	}
}
