/*
 * PassengerImpl.java
 *
 * Created on 5. februar 2001, 23:39
 */

package com.bekk.dbcdemo;

/**
 * This is a simple implementation of a Passenger
 *
 * @author <a href="mailto:aslak.hellesoy@bekk.no">Aslak Hellesy</a>
 */
public class PassengerImpl implements Passenger {

	private final String destination_;
	private final int handLuggageWeight_;
	private final boolean hasTicket_;

	public PassengerImpl( String destination, int handLuggageWeight, boolean hasTicket ) {
		destination_ = destination;
		handLuggageWeight_ = handLuggageWeight;
		hasTicket_ = hasTicket;
	}

	public String getDestination() {
		return destination_;
	}

	public int getHandLuggageWeight() {
		return handLuggageWeight_;
	}

	public boolean hasTicket() {
		return hasTicket_;
	}
}
